unit TweedeGraadsFunctie;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    ScrollBarOndergrens: TScrollBar;
    ScrollBarBovengrens: TScrollBar;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel6: TPanel;
    Panel5: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Label1: TLabel;
    Label10: TLabel;
    Uit_f: TEdit;
    Uit_g: TEdit;
    Uit_a: TEdit;
    Uit_b: TEdit;
    Uit_c: TEdit;
    Uit_d: TEdit;
    Uit_1: TEdit;
    Uit_2: TEdit;
    Uit_3: TEdit;
    Uit_4: TEdit;
    Uit_5: TEdit;
    Uit_6: TEdit;
    Uit_7: TEdit;
    Uit_8: TEdit;
    Uit_p: TEdit;
    KnopTekenG: TButton;
    KnopTekenP: TButton;
    KnopWisScherm: TButton;
    KnopStopGenereren: TButton;
    KnopRaaklijnenExact: TButton;
    KnopNulpuntenNumeriek: TButton;
    KnopExtremeWaardeParaboolABCformule: TButton;
    KnopNulpuntenParaboolABCformule: TButton;
    KnopReset: TButton;
    KnopTekenF: TButton;
    KnopOppervlaktebepaling: TButton;
    KnopExtremeWaarden: TButton;
    KnopFunctiegenerator: TButton;
    ScrollBarDomein: TScrollBar;
    GroupBox1: TGroupBox;
    ScrollBarc: TScrollBar;
    ScrollBarb: TScrollBar;
    ScrollBara: TScrollBar;
    ScrollBard: TScrollBar;
    Panel9: TPanel;
    Button1: TButton;
    Panel11: TPanel;
    Button2: TButton;
    Panel12: TPanel;
    Button3: TButton;
    KnopWisSchermKopie: TButton;
    KnopResetKopie: TButton;
    GroupBox5: TGroupBox;
    Panel3: TPanel;
    Panel4: TPanel;
    Uit_9: TEdit;
    procedure FormActivate(Sender: TObject);
    procedure KnopwisschermClick(Sender: TObject);
    procedure ScrollBaraScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure ScrollBarbScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure ScrollBarcScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure KnopResetClick(Sender: TObject);
    procedure KnopTekenFClick(Sender: TObject);
    procedure KnopNulpuntenNumeriekClick(Sender: TObject);
    procedure KnopExtremeWaardeParaboolABCformuleClick(Sender: TObject);
    procedure KnopNulpuntenParaboolABCformuleClick(Sender: TObject);
    procedure ScrollBardScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure KnopTekenGClick(Sender: TObject);
    procedure KnopFunctiegeneratorClick(Sender: TObject);
    procedure KnopStopGenererenClick(Sender: TObject);
    procedure KnopRaaklijnenExactClick(Sender: TObject);
    procedure KnopExtremeWaardenClick(Sender: TObject);
    procedure KnopTekenPClick(Sender: TObject);
    procedure KnopOppervlaktebepalingClick(Sender: TObject);
    procedure ScrollBarOndergrensScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure ScrollBarBovengrensScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure ScrollBarDomeinScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);

  private
    { Private declarations }
  public
    { Public declarations }
       procedure plaatspixel(x,y: real; Kleur: TColor);
       procedure ToonFunctievoorschriftBouwschema;
       procedure ToonFunctievoorschrift;
       procedure TekenAssenstelsel;
       procedure FunctiePlotten(k:char);
       procedure FunctieWissen(k:char);
       procedure wisscherm;
       procedure uitvoer;
       procedure wisuitvoer;
       procedure ExtremeWaardeParaboolABCformule;
       procedure NulpuntenParaboolABCformule;
       procedure ExtremeWaarden;
       procedure RaaklijnenPlotten;
       procedure Oppervlaktebepaling(i:byte);
       procedure OppervlakVullen(xx:real);
       procedure OppervlakWissen(xx:real);
       function conversiex(x:real):integer;
       function conversiey(y:real):integer;
       function p(x:real):real;
       function f(x:real):real;
       function g(x:real):real;
       function r(x:real):real;
       function v(x:real):real;
       function conI (i:integer): string;
       function conR (r:real): string;
  end;

const interval=0.001; m=10; pix=696;
      x0=m+(pix div 2); y0=m+(pix div 2);
      KleurRectangle=clGray; KleurAssen=clPurple;
      clGrafiekvenster=clWhite;
var
  Form1                                           : TForm1;
  stoppen                                         : boolean;
  gereset                                         : boolean;
  dint,dmin,dmax                                  : integer;
  a,b,c,d,x,y,x1,x2,xo,xb,opp,xmax,ymax,dis,aa,bb : real;

implementation

{$R *.dfm}

function Tform1.p(x:real):real;
begin
   p:=(1/4)*d*x*x*x*x+(1/3)*a*x*x*x+(1/2)*b*x*x+c*x;
end; {De primitieve van f voor oppervlakteberekening}

function Tform1.f(x:real):real;
begin
   f:=(d*x*x*x)+(a*x*x)+(b*x)+c;
end; {De te onderzoeken functie f}

function Tform1.g(x:real):real;
begin
   g:=3*d*x*x+2*a*x+b;
end; {De afgeleide van f voor de richtingscoefficienten van de raaklijnen}

function Tform1.r(x:real):real;
begin
   r:=(aa*x)+bb;
end; {Functie voor de raaklijnen}

function Tform1.v(x:real):real;
begin
   v:=x;
end; {Functie voor het vullen van een oppervlak (inverse functie)}

Procedure TForm1.ToonFunctievoorschriftBouwschema;
begin
  uit_p.text:='y ='#188+'dx^4'+'+1/3ax'+#179+'+'#189+'bx'+#178+'+cx';
  uit_f.text:='y =dx'+#179+'+ax'+#178+'+bx'+'+c';
  uit_g.text:='y =3dx'+#178+'+2ax'+'+b';
end;

Procedure TForm1.ToonFunctievoorschrift;
var t4,t1,t2,t3 : string[4];
    S4,S1,S2,S3 : string[20];
    g4,g1,g2,g3 : string[5];
    e4,e1,e2,e3 : string[4];
begin
   if d<0 then t4:='-';
   if d=0 then t4:=' ';
   if d>0 then t4:=' ';

   if a<0then t1:='-';
   if a=0 then t1:='+';
   if a>0 then t1:='+';

   if b<0 then t2:='-';
   if b=0 then t2:='+';
   if b>0 then t2:='+';

   if c<0 then t3:='-';
   if c=0 then t3:='+';
   if c>0 then t3:='+';

   if d>0 then g4:=conR(0.25*d);
   if d<0 then g4:=conR(-0.25*d);
   if a>0 then g1:=conR(0.33*a);
   if a<0 then g1:=conR(-0.33*a);
   if b>0 then g2:=conR(0.5*b);
   if b<0 then g2:=conR(-0.5*b);
   if c>0 then g3:=conR(c);
   if c<0 then g3:=conR(-c);

   if d=0 then e4:=' ' else e4:=' x^4';
   if a=0 then e1:=' ' else e1:=' x'+#179;
   if b=0 then e2:=' ' else e2:=' x'+#178;
   if c=0 then e3:=' ' else e3:=' x';

   S4:=t4+g4+e4;
   S1:=t1+g1+e1;
   S2:=t2+g2+e2;
   S3:=t3+g3+e3;

   Uit_p.Text:='y='+S4+S1+S2+S3;

   if d<0 then t4:=' ';
   if d=0 then t4:=' ';
   if d>0 then t4:=' ';

   if a<0 then t1:='-';
   if a=0 then t1:=' ';
   if a>0 then t1:='+';

   if b<0 then t2:='-';
   if b=0 then t2:=' ';
   if b>0 then t2:='+';

   if c<0 then t3:='-';
   if c=0 then t3:=' ';
   if c>0 then t3:='+';

   if d>0 then g4:=conR(d)else g4:=conR(-d);
   if a>0 then g1:=conR(a)else g1:=conR(-a);
   if b>0 then g2:=conR(b)else g2:=conR(-b);
   if c>0 then g3:=conR(c)else g3:=conR(-c);

   if d=0 then e4:=' ' else e4:='x'+#179;
   if a=0 then e1:=' ' else e1:='x'+#178;
   if b=0 then e2:=' ' else e2:='x';

   S4:=t4+g4+e4;
   S1:=t1+g1+e1;
   S2:=t2+g2+e2;
   S3:=t3+g3;

   Uit_f.Text:='y='+S4+S1+S2+S3;

   if d<0 then t4:='-';
   if d=0 then t4:=' ';
   if d>0 then t4:=' ';

   if a<0 then t1:='-';
   if a=0 then t1:=' ';
   if a>0 then t1:='+';

   if b<0 then t2:='-';
   if b=0 then t2:=' ';
   if b>0 then t2:='+';

   if d>0 then g4:=conR(3*d) else g4:=conR(-3*d);
   if a>0 then g1:=conR(2*a) else g1:=conR(-2*a);
   if b>0 then g2:=conR(b) else g2:=conR(-b);

   if d=0 then e4:=' ' else e4:='x'+#178;
   if a=0 then e1:=' ' else e1:='x';

   S4:=t4+g4+e4;
   S1:=t1+g1+e1;
   S2:=t2+g2;

   Uit_g.Text:='y='+S4+S1+S2;
end;

procedure TForm1.uitvoer;
begin
  Uit_a.text:=conR(a); Uit_b.text:=conR(b);
  Uit_c.text:=conR(c); Uit_d.text:=conR(d);
  Uit_6.text:=conR(xo); Uit_7.text:=conR(xb);
  NulpuntenParaboolABCformule;
  ExtremeWaardeParaboolABCformule;
  ExtremeWaarden;
end;

procedure TForm1.Wisuitvoer;
begin
 Uit_1.Text:=' '; Uit_2.Text:=' '; Uit_3.Text:=' ';
 Uit_4.Text:=' '; Uit_5.Text:=' '; Uit_6.Text:=' ';
 Uit_7.Text:=' '; Uit_8.Text:=' '; Uit_9.Text:=' ';
end;

function TForm1.conI (i:integer): string;
begin
  conI:=IntToStr(i);
end;

function TForm1.conR (r:real): string;
begin
  conR:=FloatToStrF(r,ffFixed,1,2);
end;

procedure TForm1.NulpuntenParaboolABCformule;
begin
   if a<>0 then Dis:=((b*b)-(4*a*c));
   if ((Dis>=0) and (a<>0) and (d=0)) then
     begin
      x1:=(-b-sqrt(Dis))/(2*a);
      x2:=(-b+sqrt(Dis))/(2*a);
      Uit_1.Text:=conR(x1)+' '+conR(x2);
      Canvas.TextOut(conversiex(x1),conversiey(0),conR(x1));
      Canvas.TextOut(conversiex(x2),conversiey(0),conR(x2));
     end;
  if dis<0 then  Uit_1.Text:='D < 0';
  if a=0   then  Uit_1.Text:='a = 0';
  if d<>0  then Uit_1.Text:='D <> 0';
end;

procedure TForm1.RaaklijnenPlotten;
const dxx=0.1;
var   xx: real;
begin
  xx:=dmin;
   while ((xx<=dmax) and (not stoppen)) do
   begin
    aa:=g(xx); bb:=f(xx)-(xx*g(xx));
    Canvas.MoveTo(conversiex(dmin),conversiey(r(dmin)));
    Canvas.LineTo(conversiex(dmax),conversiey(r(dmax)));
    sleep(5);
    xx:=xx+dxx;
    application.processmessages;
   end;
end;

procedure TForm1.TekenAssenstelsel;
var i : integer;
begin
 for i:=1 to pix do
  begin
   Canvas.Pixels[x0-(pix div 2)+i,y0]:=KleurAssen;;
   Canvas.Pixels[x0-(pix div 2)+i,y0+pix div 2]:=KleurRectangle;
   Canvas.Pixels[x0-(pix div 2)+i,y0-pix div 2]:=KleurRectangle;
   Canvas.Pixels[x0,y0-(pix div 2)+i]:=KleurAssen;
   Canvas.Pixels[x0- pix div 2,y0-(pix div 2)+i]:=KleurRectangle;
   Canvas.Pixels[x0+ pix div 2,y0-(pix div 2)+i]:=KleurRectangle;
   Canvas.TextOut(pix-25,(pix div 2)-7,'x ['+FloatToStr(dmax)+']');
   Canvas.TextOut(m+(pix div 2)+5,m+1,'y '+'['+FloatToStr(dmax)+']');
  end;
end;

procedure TForm1.wisscherm;
begin
  Canvas.Brush.Color:=clGrafiekvenster;
  Canvas.Rectangle(m,m,m+pix+1,m+pix+1);
  Canvas.Refresh; TekenAssenstelsel;
end;

function TForm1.conversiex(x:real):integer;
var p:integer; Sx: real;
begin
 Sx:=pix div (dmax-dmin);
 conversiex:=x0+ROUND(x*Sx);
end;

function TForm1.conversiey(y:real):integer;
var q:integer; Sy:real;
begin
 Sy:=(pix div 2) div dmax;
 conversiey:=y0-ROUND(y*Sy);
end;

procedure Tform1.plaatspixel(x,y: real; kleur: TColor);
begin
  application.processmessages;
  if x<(dmin+2*interval) then TekenAssenstelsel;
  if ((conversiex(x)>m) and (conversiex(x)<m+pix) and
       (conversiey(y)>m) and (conversiey(y)<m+pix)) then
         Canvas.Pixels[conversiex(x),conversiey(y)]:=kleur;
end;

procedure TForm1.FunctiePlotten(k:char);
var kleur: TColor;
begin
  x:=dmin;
  if k='p' then begin y:=p(x); Canvas.MoveTo(conversiex(x),conversiey(p(x))); kleur:=clOlive;  end;
  if k='f' then begin y:=f(x); Canvas.MoveTo(conversiex(x),conversiey(f(x))); kleur:=clPurple; end;
  if k='g' then begin y:=g(x); Canvas.MoveTo(conversiex(x),conversiey(g(x))); kleur:=clRed;    end;
  if ((d<>0) or (a<>0)) then
   if k='r' then begin y:=r(x); Canvas.MoveTo(conversiex(x),conversiey(r(x))); kleur:=clRed  ; end;
  While ((x<=dmax) and (not stoppen)) do
    begin
     if k='p' then begin y:=p(x); Canvas.LineTo(conversiex(x),conversiey(p(x))); kleur:=clOlive;  end;
     if k='f' then begin y:=f(x); Canvas.LineTo(conversiex(x),conversiey(f(x))); kleur:=clPurple; end;
     if k='g' then begin y:=g(x); Canvas.LineTo(conversiex(x),conversiey(g(x))); kleur:=clRed;    end;
     if ((d<>0) or (a<>0)) then
     if k='r' then begin y:=r(x); Canvas.LineTo(conversiex(x),conversiey(r(x))); kleur:=clRed  ; end;
     x:=x+interval;
    end;
  ToonFunctievoorschrift;
end;

procedure TForm1.FunctieWissen(k:char);
var kleur: TColor;
begin
  x:=dmin;
  While ((x<=dmax) and (not stoppen)) do
    begin
     if k='p' then y:=p(x);
     if k='f' then y:=f(x);
     if k='g' then y:=g(x);
     if ((d<>0) or (a<>0)) then
      if k='r' then y:=r(x);
     x:=x+interval;
     plaatspixel(x,y,clGrafiekvenster);
    end;
   ToonFunctievoorschrift;
end;

procedure TForm1.OppervlakVullen(xx:real);
const marge=0;
begin
  x:=dmin;
  While ((x<=dmax) and (not stoppen)) do
    begin
     y:=v(xx);
     if ((x>marge) and (x<f(y)-marge)) then plaatspixel(y,x,clGreen);
     if ((x<-marge) and (x>f(y)+marge)) then plaatspixel(y,x,clGreen);
     x:=x+interval;
    end;
end;

procedure TForm1.OppervlakWissen(xx:real);
const marge=0;
begin
  x:=dmin;
  While ((x<=dmax) and (not stoppen)) do
    begin
     y:=v(xx);
     if ((x>marge) and (x<f(y)-marge)) then plaatspixel(y,x,clGrafiekvenster);
     if ((x<-marge) and (x>f(y)+marge)) then plaatspixel(y,x,clGrafiekvenster);
     x:=x+interval;
    end;
end;

procedure TForm1.Oppervlaktebepaling(i:byte);
var   xx,dy,xstart,xstop: real;
begin
   dy:=dmax/(pix div 4);
   begin
    NulpuntenParaboolABCformule;
    if x1<x2 then begin xstart:=x1; xstop:=x2; end;
    if x1>x2 then begin xstart:=x2; xstop:=x1; end;
    xx:=xo;
    while xx<=xb do
     begin
      if i=1 then Oppervlakvullen(xx);
      if i=0 then Oppervlakwissen(xx);
      xx:=xx+dy;
      opp:=p(xx)-p(xo);
      uit_8.text:=conR(opp);
     end;
   end;
end;

procedure TForm1.KnopNulpuntenParaboolABCformuleClick(Sender: TObject);
begin
  NulpuntenParaboolABCformule;
end;

procedure TForm1.ExtremeWaardeParaboolABCformule;
begin
  if ((a<>0) and (d=0)) then
    begin
     ymax:=f(-b/(2*a));
     Uit_2.Text:=conR(-b/(2*a))+'  '+conR(ymax);
     Canvas.TextOut(conversiex(-b/(2*a)),conversiey(ymax),conR(-b/(2*a))+' '+(conR(ymax)));
    end else
  if a=0 then Uit_2.Text:='a = 0';
  if d<>0 then Uit_2.Text:='D <> 0';
end;

procedure TForm1.KnopExtremeWaardeParaboolABCformuleClick(Sender: TObject);
begin
 ExtremeWaardeParaboolABCformule;
end;

procedure TForm1.KnopNulpuntenNumeriekClick(Sender: TObject);
const                                       max=100;
type             NulpuntenGeheugen=array[1..max] of real;
var N          : NulpuntenGeheugen;
    Ns         : string;
    x,y,dx,m   : real;
    i,s        : integer;
begin
 wisscherm;
 for i:=1 to max do N[i]:=-111;
 i:=1; dx:=0.01; m:=5*dx; x:=dmin; s:=0; Ns:=' ';
 while x<=dmax do
  begin
    y:=f(x);
    plaatspixel(x,y,clBlue);
    sleep(s);
    if ((y>-m) and (y<m)) then
      begin
       N[i]:=x; inc(i); Ns:=Ns+conR(x)+' ';
       Uit_5.text:=' ... zoeken ... '+conR(x)+' '+conR(y);
       s:=100;
      end;
    if not ((y>-m) and (y<m)) then s:=0;
    x:=x+dx;
  end;
  Uit_4.text:=' '+conI(i-1); Uit_5.text:=Ns; FunctiePlotten('f');
end;

procedure TForm1.KnopRaaklijnenExactClick(Sender: TObject);
begin
  RaaklijnenPlotten;
end;

procedure TForm1.KnopFunctiegeneratorClick(Sender: TObject);
const max=4;
begin
 stoppen:=false;
 while not stoppen do
  begin
   wisscherm; Randomize;
   d:=Random(max)- (max div 2);
   a:=Random(max)- (max div 2);
   b:=Random(max)- (max div 2);
   c:=Random(max)- (max div 2);
   uitvoer;
   FunctiePlotten('f'); FunctiePlotten('g'); FunctiePlotten('p');
   {OppervlakteBepaling(1);
   OppervlakteBepaling(0);}
   FunctiePlotten('f'); FunctiePlotten('g'); FunctiePlotten('p');
   RaaklijnenPlotten;
   sleep(350); wisscherm; wisuitvoer;
  end;
 stoppen:=false;
end;

procedure TForm1.ExtremeWaarden;
var dis,aa,bb,cc,x1,x2,y1,y2: real;
begin
   if d<>0 then
    begin
      aa:=3*d; bb:=2*a; cc:=b;
      if aa<>0 then dis:=((bb*bb)-(4*aa*cc));
      if ((dis>=0) and (aa<>0)) then
       begin
        x1:=(-bb-sqrt(dis))/(2*aa); y1:=f(x1);
        x2:=(-bb+sqrt(dis))/(2*aa); y2:=f(x2);
       end;
      if dis>=0 then
       begin
        Uit_3.Text:=conR(x1)+' '+conR(y1)+'   '+conR(x2)+' '+conR(y2);
        Canvas.TextOut(conversiex(x1),conversiey(y1),conR(x1)+' '+conR(y1));
        Canvas.TextOut(conversiex(x2),conversiey(y2),conR(x2)+' '+conR(y2));
       end;
       if dis<0 then Uit_3.Text:='... geen gevonden ..';
    end;

   if ((d=0) and (a<>0)) then
    begin
     aa:=a; bb:=b;
     x1:=-bb/(2*aa); y1:=f(x1);
     Uit_3.Text:=conR(x1)+' '+conR(y1);
    end;
end;

procedure TForm1.KnopExtremeWaardenClick(Sender: TObject);
begin
 ExtremeWaarden;
end;

procedure TForm1.KnopStopGenererenClick(Sender: TObject);
begin
  stoppen:=not stoppen;
end;

procedure TForm1.KnopTekenPClick(Sender: TObject);
begin
  stoppen:=false; FunctiePlotten('p');
end;

procedure TForm1.KnopTekenFClick(Sender: TObject);
begin
  stoppen:=false; FunctiePlotten('f');
end;

procedure TForm1.KnopTekenGClick(Sender: TObject);
begin
  stoppen:=false; FunctiePlotten('g');
end;

procedure TForm1.KnopwisschermClick(Sender: TObject);
begin
  wisscherm; stoppen:=true;
end;

procedure TForm1.KnopResetClick(Sender: TObject);
begin
  d:=0; Uit_d.Text:=conR(d);
  a:=0; Uit_a.Text:=conR(a);
  b:=0; Uit_b.Text:=conR(b);
  c:=0; Uit_c.Text:=conR(c);
  wisuitvoer; gereset:=true;
  ToonFunctievoorschriftBouwschema;
end;

procedure TForm1.KnopOppervlaktebepalingClick(Sender: TObject);
begin
 OppervlakteBepaling(1);
end;

procedure TForm1.ScrollBarOndergrensScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
 xo:=ScrollPos; xo:=xo/10; uit_6.text:=conR(xo);
end;

procedure TForm1.ScrollBarBovengrensScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  xb:=ScrollPos; xb:=xb/10; uit_7.text:=conR(xb);
end;

procedure TForm1.ScrollBardScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if gereset then ScrollPos:=round(d);
  d:=ScrollPos; d:=d/10; Uit_d.Text:=conR(d);
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBaraScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if gereset then ScrollPos:=round(a);
  a:=ScrollPos; a:=a/10; Uit_a.Text:=conR(a);
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBarbScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if gereset then ScrollPos:=round(b);
  b:=ScrollPos; b:=b/10; Uit_b.Text:=conR(b);
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBarcScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if gereset then ScrollPos:=round(c);
  c:=ScrollPos; c:=c/10; Uit_c.Text:=conR(c);
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBarDomeinScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  dint:=ScrollPos; dmin:=-dint div 2; dmax:=-dmin;
  TekenAssenstelsel; stoppen:=false;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 application.processmessages;
 canvas.Font.Size:=8;
 stoppen:=false; gereset:=false;
 dint:=10; dmin:=-dint div 2; dmax:=-dmin;
 d:=0; Uit_d.Text:=conR(d);
 a:=0; Uit_a.Text:=conR(a);
 b:=0; Uit_b.Text:=conR(b);
 c:=0; Uit_c.Text:=conR(c);
 xo:=-2; Uit_6.Text:=conR(xo);
 xb:=+2; Uit_7.Text:=conR(xb);
 ToonFunctievoorschriftBouwschema; wisscherm;
end;

end.
